/*
    v0.01 - original
    v0.02 - incorporates [Cp] patch
    v0.03 - changed .ini options to allow vcr_scart - vcr_scart

todo:
- tap does not inhibit << >> keys - fixed
- flips back to bax 2 on aspect ratio change - fixed
- filter on/off button
- automatically swap to be the first tap
- support for >2 toppies
- differentiate between toppy on vcr scart, and other device [use code on slow blanking]
- more .ini settings
- maybe add option to alow 2nd press to put it in pass through mode
- maybe add option to alow 2nd press to show which toppy is active

- offer vcr_scart to vcr_scart
  topfield1: no change
  topfield2: don't touch tv scart outtput
             when active, set vcr_scart = med/high
             when in active, set vcr_scart = low



1 remote - 2 toppies
--------------------
- tap should be first in load order
- tap should run on both toppies
- .ini file sets parameters

use 'sat' key to select active box
- 1st press of tv/stb button, shows status
- 2nd press (within 3 seconds) switches active toppy


a)
      ______             ________________             ______________
     |      |           |                |           |              |
     |  tv  +---scart---+tv           vcr<---scart---+tv         vcr+----scart----
     |______|           |________________|           |______________|
                        topfield1                    topfield2

toppy1:
- comms_scart = 1       //0=use tv_scart for comms,  1=use vcr_scart for comms
- comms_dir = 0         //0=input,                   1=output
- tv_scart_mode = 2     //0=do not adjust tv_scart,  1=disable tv_scart when inactive,   2=passthrough vcr_scart to tv_scart when inactive
- vcr_scart_mode = 0    //0=do not adjust vcr_scart, 1=disable vcr_scart when inactive,  2=passthrough tv_scart to vcr_scart when inactive

- when 'active'
  - monitors the 'sat' button
  when pressed
  - disables its remote
  - sets itself in passthrough mode
  - goes 'inactive'

- when 'inactive'
  - ignores the 'sat' button
  - monitors the comms_scart input
  when set
  - enables its remote
  - enables its tv_scart output
  - goes 'active'


toppy 2:
- comms_scart = 0       //0=use tv_scart for comms,  1=use vcr_scart for comms
- comms_dir = 1         //0=input,                   1=output
- tv_scart_mode = 1     //0=do not adjust tv_scart,  1=disable tv_scart when inactive,   2=passthrough vcr_scart to tv_scart when inactive
- vcr_scart_mode = 0    //0=do not adjust vcr_scart, 1=disable vcr_scart when inactive,  2=passthrough tv_scart to vcr_scart when inactive

- when 'active'
  - monitors the 'sat' button
  when pressed
  - disables its remote
  - disables its comms_scart output
  - goes 'inactive'

- when 'inactive'
  - monitors the 'sat' button
  when pressed
  - enables its remote
  - enables its comms_scart output
  - (enables its tv_scart output)
  - goes 'active'





b)
      ______             ________________
     |      |           |                |
     |  tv  +---scart---+tv           vcr<---scart---+
     |______|           |________________|           |
                        topfield1                    |
     ______              ________________            |
     |      |           |                |           |
     |  tv  +---scart---+tv           vcr+---scart--->
     |______|           |________________|
                        topfield2

toppy1:
- comms_scart = 1       //0=use tv_scart for comms,  1=use vcr_scart for comms
- comms_dir = 0         //0=input,                   1=output
- tv_scart_mode = 0     //0=do not adjust tv_scart,  1=disable tv_scart when inactive,   2=passthrough vcr_scart to tv_scart when inactive
- vcr_scart_mode = 0    //0=do not adjust vcr_scart, 1=disable vcr_scart when inactive,  2=passthrough tv_scart to vcr_scart when inactive

- when 'active'
  - monitors the 'sat' button
  when pressed
  - disables its remote
  - goes 'inactive'

- when 'inactive'
  - ignores the 'sat' button
  - monitors the comms_scart input
  when set
  - enables its remote
  - goes 'active'


toppy 2:
- comms_scart = 1       //0=use tv_scart for comms,  1=use vcr_scart for comms
- comms_dir = 1         //0=input,                   1=output
- tv_scart_mode = 0     //0=do not adjust tv_scart,  1=disable tv_scart when inactive,   2=passthrough vcr_scart to tv_scart when inactive
- vcr_scart_mode = 0    //0=do not adjust vcr_scart, 1=disable vcr_scart when inactive,  2=passthrough tv_scart to vcr_scart when inactive

- when 'active'
  - monitors the 'sat' button
  when pressed
  - disables its remote
  - disables its comms_scart output
  - goes 'inactive'

- when 'inactive'
  - monitors the 'sat' button
  when pressed
  - enables its remote
  - enables its comms_scart output
  - goes 'active'

*/




/*
juwlz .ini suggestion

Sample ini / readme file with default settings:

TV/Sat, 1, Verbose, 1
1, "Toppy 1", White, Black
2, "Toppy 2", Black, White

# Line 1 fields (global config):
# 1. TAP activation button (must be the same on all Toppies)
# 2. Enable button for this Toppy (must be different for each Toppy)
# 3. Switching style (Verbose | Silent)
# 4. Confirmation style
# 5 ... optional Confirmation parameters
#
# Config line for each Toppy
# 1. Enable button (anything except Activation button or Menu button)
# 2. Toppy ID
# 3. Background colour for confirmation
# 4. Foreground colour for confirmation
#
# Global config detail:
# Confirmation style and parameters
#
# 0 - Silent, no confirmation
# 1 - Text (display text in column 2 in Foreground colour text on Background colour
#      Options [Duration, X offset, Y offset]
#      Default is to display centered horizontally, and vertically
        ToppyNum/(NumToppies+1) down the screen (e.g. 1/3 way down for Toppy 1,
        2/3 down for Toppy2, etc.)
#      Offsets of -1 (or omitted) mean "centred"
# 2 - Blob
#      Options [Duration, X offset, Y offset]
#      Default is to display first character of Toppy ID in Foreground colour
#      text in a small circle of Background colour in top right corner.
#      Negative offsets are relative to right/bottom instead of left/top
# 3 - Frame
#      Options [Duration, numpixels]
#      Default is to display a 5 pixel border in background colour
#
# Example:
# TV/Sat, Red, Silent, 3, 2, 10
# Red, "Old Toppy - 160GB", Red, White
# Yellow, "New Toppy - 250GB", Yellow Black
#
# This uses TV/Sat as the activation key, doesn't display options when TV/Sat is
# first pressed, has the Red button as the activation key for this Toppy,
# displays a 10 pixel wide Red frame around the picture for 2 time units to
# confirm that the Red button has been pressed and the Red Toppy has been enabled.
#
# Example:
# TV/Sat, TV/Radio, Verbose, 1
# TV/Radio, "Silver Toppy", White, Black

# Opt, "Black Panther", Black, White
# 0, "Disable all Toppies", Red, Yellow
#
# This uses TV/Sat as the activation key, displays 3 lines of choices when the TV/Sat button is pressed:
#        TV/Radio:  Silver Toppy   (displayed in Black text on White background)
#        Opt:  Black Panther   (displayed in White text on Black background)
#        0:   Disable all Toppies   (displayed in Yellow text on Red background)
#
# When TV/Radio is pressed, it confirms enabled Toppy by displaying "Silver
# Toppy" in Black text on White background, 1/4 of the way down the screen
#
# displays a 10 pixel wide Red frame around the picture for 2 time units to
# confirm that the Red button has been pressed and the Red Toppy has been enabled.
#

NB: If there's a nice friendly configuration screen, the buttons and colours
could be held in the ini file as the button codes and hex values without making
it too obscure. Of course, that could still be the case even if there isn't a
nice friendly config screen. It would just be less ... friendly.
Julie
*/

#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <tap.h>
#include "exTap.h"
#include "tf5800.h"
#include "libFirebird.h"
//#include "fnames1408.h"


#define ID_USERTAP 0xbdb03503
TAP_ID( ID_USERTAP );

TAP_PROGRAM_NAME("remote_sharer v0.03");
TAP_AUTHOR_NAME("bdb");
TAP_DESCRIPTION("a tap to share 1 remote with 2 toppies");
TAP_ETCINFO(__DATE__);

//----------------------------------------------------------------------------
//
//tsr_commander stuff
//
#include "TSRCommander.inc"

void TSRCommanderConfigDialog();
bool TSRCommanderExitTAP();
int is_tsr_commander_running(void);

//----------------------------------------------------------------------------
//
//main
//
type_menu main_menu;

int TAP_Main(void);
dword TAP_EventHandler(word event, dword param1, dword param2);
int main_menu_handler(type_menu *menu, dword param1);
int key_handler(dword param1);

int init(void);
int close(void);

void set_remote(int remote_id);
void remote_status(void);
int on_keypress(int param1);
int one_second_enabled = 1;
dword one_second = 0;
void one_second_update(void);
int set_fw_addresses();

int stb_timeout = 0;
int stb_state = 0;
int active = 1;
int use_alt_remote = 0;
//----------------------------------------------------------------------------
int ini_init();
int ini_update();
//----------------------------------------------------------------------------
#define COMMS_SCART_TV              0
#define COMMS_SCART_VCR             1
#define COMMS_DIR_INPUT             0
#define COMMS_DIR_OUTPUT            1
#define TV_SCART_MODE_NONE          0
#define TV_SCART_MODE_DISABLE       1
#define TV_SCART_MODE_PASSTHROUGH   2
//----------------------------------------------------------------------------
//default values if no .ini
int box_id = 1;                     //{1,2}
char box_name[0x20] = "Toppy 1";    //
int comms_scart = 0;                //0=use tv_scart for comms,  1=use vcr_scart for comms
int comms_dir = 0;                  //0=input,                   1=output
int tv_scart_mode = 2;              //0=do not adjust tv_scart,  1=disable tv_scart when inactive,   2=passthrough vcr_scart to tv_scart when inactive
int vcr_scart_mode = 0;             //0=do not adjust vcr_scart, 1=disable vcr_scart when inactive,  2=passthrough tv_scart to vcr_scart when inactive
int menu_enable = 0;                //1=enable the menu
int menu_key = RKEY_Recall;         //1=enable the menu key
int debug = 0;                      //1=enable serial debug messages
int splash_enable = 1;              //1=enable this initial splash osd
dword fgcolour = COLOR_White;       //osd text colour
dword bkcolour = RGB(3,5,10);       //osd background text colour
dword remote_id = 3;                //3 = default, -1=don't use
dword remote0 = 0x23400a;           //Masterpiece ? = [tf5810]
dword remote1 = 0x49000a;           //Masterpiece ?
dword remote2 = 0x49990a;           //"old" 5000 series ?
dword remote3 = 0x20df0a;           //the default   [tf5800]
//----------------------------------------------------------------------------
void *fw_AVMatrixWriteRegister;
void *fw_AVMatrixReadRegister;
void *fw_set_tv_slow_blanking;
void *fw_task_e300;
volatile byte *fw_wssmode;
volatile byte *fw_av_stb;
volatile byte *fw_av_matrix0;
volatile byte *fw_av_matrix1;
volatile byte *fw_av_matrix2;
volatile byte *fw_av_matrix3;
volatile byte *fw_av_matrix4;
volatile byte *fw_av_matrix5;
dword patch_set_tv_slow_blanking[2];
dword patch_click_push[2];
//----------------------------------------------------------------------------
//
//tsr_commander stuff
//
bool TSRCommanderExitTAP()
{
    close();
    TAP_Exit();
    return FALSE;
}

void TSRCommanderConfigDialog()
{
    TAP_ExitNormal();
    ShowMenu(&main_menu);
}

int is_tsr_commander_running(void)
{
    int i;
	type_TAPProcess *TAPProcess;

    if (fw_tap_table <= 0) return 0;

    for (i=0; i<16; i++) {
        TAPProcess = (type_TAPProcess *)(fw_tap_table + (i*32));
        if (TAPProcess->firmwaregp) {
            if (TAPProcess->header) {
                if (TAPProcess->header->id == 0x807a10b2) {  //tsr_commander
                    return 1;
                }
                if (TAPProcess->header->id == 0x81001021) {  //tap_commander
                    return 1;
                }
            }
        }
    }
    return 0;
}

//----------------------------------------------------------------------------
//
//print multiline message to OSD
//  500=vertical position(0-576)
//  RGB(3,5,10)=background colour(dark blue)
//  300=hold time(3 seconds)
//  0=blocking
//
void oprintf(const void *fmt, ...)
{
    va_list argp;

    va_start(argp, fmt);
    vsprintf(strLog, fmt, argp);
    if (debug) TAP_Print("\n%s", strLog);
    ShowMessage_y(strLog, 500, RGB(3,5,10), 300, 0);
    va_end(argp);

    return;
}

void xyprintf(int x, int y, const void *fmt, ...)
{
    va_list argp;

    va_start(argp, fmt);
    vsprintf(strLog, fmt, argp);
    if (debug) TAP_Print("\n%s", strLog);
    ShowMessage_xy(strLog, x, y, fgcolour, bkcolour, 100, 0);
    va_end(argp);

    return;
}
//-----------------------------------------------------------------------------
/*
    box_id
    box_name
    comms_scart
    comms_dir
    tv_scart_mode
    vcr_scart_mode
    menu_enable
    menu_key
    debug
    splash_enable
    fgcolour - COLOR_White,
    bkcolour - RGB(3,5,10)

*/
int ini_init()
{
    int ini_location;
    char str[0x20];

    ini_location = INIOpenFile("remote_sharer.ini", "remote_sharer");
    box_id = INIGetInt("box_id", box_id, 0x80000000, 0x7fffffff);
    INIGetString("box_name", box_name, box_name, sizeof(box_name));
    comms_scart = INIGetInt("comms_scart", comms_scart, 0x80000000, 0x7fffffff);
    comms_dir = INIGetInt("comms_dir", comms_dir, 0x80000000, 0x7fffffff);
    tv_scart_mode = INIGetInt("tv_scart_mode", tv_scart_mode, 0x80000000, 0x7fffffff);
    vcr_scart_mode = INIGetInt("vcr_scart_mode", vcr_scart_mode, 0x80000000, 0x7fffffff);
    menu_enable = INIGetInt("menu_enable", menu_enable, 0x80000000, 0x7fffffff);
    menu_key = INIGetHexDWord("menu_key", menu_key, 0x00000000, 0xffffffff);
    debug = INIGetHexDWord("debug", debug, 0x00000000, 0xffffffff);
    splash_enable = INIGetInt("splash_enable", splash_enable, 0x80000000, 0x7fffffff);
    fgcolour = INIGetHexDWord("fgcolour", fgcolour, 0x00000000, 0xffffffff);
    bkcolour = INIGetHexDWord("bkcolour", bkcolour, 0x00000000, 0xffffffff);
    remote_id = INIGetInt("remote_id", remote_id, 0x80000000, 0x7fffffff);
    remote0 = INIGetHexDWord("remote0", remote0, 0x00000000, 0xffffffff);
    remote1 = INIGetHexDWord("remote1", remote1, 0x00000000, 0xffffffff);
    remote2 = INIGetHexDWord("remote2", remote2, 0x00000000, 0xffffffff);
    remote3 = INIGetHexDWord("remote3", remote3, 0x00000000, 0xffffffff);

    INICloseFile();
    ini_update();
}

int ini_update()
{
    int ini_location;

    ini_location = INIOpenFile("remote_sharer.ini", "remote_sharer");
    INISetInt("box_id", box_id);
    INISetString("box_name", box_name);
    INISetInt("comms_scart", comms_scart);
    INISetInt("comms_dir", comms_dir);
    INISetInt("tv_scart_mode", tv_scart_mode);
    INISetInt("vcr_scart_mode", vcr_scart_mode);
    INISetInt("menu_enable", menu_enable);
    INISetHexDWord("menu_key", menu_key);
    INISetHexDWord("debug", debug);
    INISetInt("splash_enable", splash_enable);
    INISetHexDWord("fgcolour", fgcolour);
    INISetHexDWord("bkcolour", bkcolour);
    INISetInt("remote_id", remote_id);
    INISetHexDWord("remote0", remote0);
    INISetHexDWord("remote1", remote1);
    INISetHexDWord("remote2", remote2);
    INISetHexDWord("remote3", remote3);

    INISaveFile("remote_sharer.ini", INILOCATION_AtSettings, "remote_sharer");
    INICloseFile();
}

//----------------------------------------------------------------------------
//
//main
//
char *tap_name;
type_menu main_menu = {
    0,
    0,
    {0},
    0,
    (char *)__tap_program_name__,
    {
        {2, "xxx",                 },
        {0, "Status",              },
        {1, "Exit Tap",            },
    },
};

//----------------------------------------------------------------------------
int TAP_Main(void)
{
    int ret;

    tap_name =  (char *)__tap_program_name__;
    if (debug) sprintf(strLog, "Opening %s", tap_name);
    if (debug) log_message(LOG_SERIAL, strLog, DELAY_SHORT);

    //determine support for different firmwares
    ret = exTAP_Init();
    if (ret < 0) {
        sprintf(strLog, "exTAP_INIT: Unsupported platform - %d:%04x", fw_sysid, _appl_version);
        log_message(LOG_SCREEN_WAIT|LOG_SERIAL, strLog, DELAY_LONG);
        return 0;
    }
    ret = set_fw_addresses();
    if (ret < 0) {
        sprintf(strLog, "set_fw_addresses: Unsupported platform - %d:%04x", fw_sysid, _appl_version);
        log_message(LOG_SCREEN_WAIT|LOG_SERIAL, strLog, DELAY_LONG);
        return 0;
    }

    init();
    if (splash_enable) sprintf(strLog, "Opening %s", tap_name);
    if (splash_enable) log_message(LOG_SCREEN_CONT, strLog, DELAY_SHORT);

    one_second = TAP_GetTick(); + (1*100);
    return 1;                 //0=application mode, 1=tsr mode
}


char menu_title_str[0x40];

int init(void)
{
    int next_box_id;

    main_menu.visible = 0;

    ini_init();
    if (use_alt_remote) {
        if (remote_id >= 0) set_remote(remote_id);
    }

    sprintf(menu_title_str, "%s - %s", box_name, tap_name);
    main_menu.fixme_titlep = menu_title_str - _tap_startAddr;

    TSRCommanderInit(0, TRUE);
    return 0;
}

int close(void)
{

    DeleteMenu(&main_menu);

    //ensure blanking patch is cleared
    if (patch_set_tv_slow_blanking[1]) {
        *(dword *)((dword)fw_set_tv_slow_blanking+0) = patch_set_tv_slow_blanking[0];
        *(dword *)((dword)fw_set_tv_slow_blanking+4) = patch_set_tv_slow_blanking[1];
    }
    //restore [Cp]
    *(dword *)((dword)fw_key_map_patch-0x24) = patch_click_push[0];
    *(dword *)((dword)fw_key_map_patch-0x20) = patch_click_push[1];

    if (splash_enable) sprintf(strLog, "Closing  %s", tap_name);
    if (splash_enable) log_message(LOG_SCREEN_WAIT|LOG_SERIAL, strLog, DELAY_SHORT);
    if (message_rgn) TAP_Osd_Delete(message_rgn);
    if (OpLog) TAP_Hdd_Fclose(OpLog);
    TSRCommanderErase();
    if (debug) TAP_Print("\nClosing %s", tap_name);
    return 0;
}

//----------------------------------------------------------------------------
dword TAP_EventHandler(word event, dword param1, dword param2)
{
    dword tick;
    dword state, subState;
    dword param[4];

    switch (event) {
        case EVT_IDLE:
//            TAP_Print("\nEVT_IDLE, event=%x, param1=%x, param2=%x", event, param1, param2);
            tick = TAP_GetTick();

            if (message_showing) {
                if (tick > message_showing) {
                    TAP_EnterNormal();
                    TAP_Osd_Delete(message_rgn);
                    message_showing = 0;
                    message_rgn = 0;
                }
            }

            if (one_second_enabled) {
                if (tick > one_second) {
                    one_second_update();
                    one_second = tick + (1*100);
//                    one_second = tick + (1*20);
                }
            }

            if (stb_timeout) {
                if (tick > stb_timeout) {
//                  if (debug) printf("\nmessage_showing=%x, stb_state=%x, active=%x", message_showing, stb_state, active);
                    if (message_showing) {
                        TAP_EnterNormal();
                        TAP_Osd_Delete(message_rgn);
                        message_showing = 0;
                        message_rgn = 0;
                    }
                    if (stb_state > 0) {
                        stb_state = 0;
                        stb_timeout = 0;
                    }
                }
            }

    		TSRCommanderWork();
            break;

        case EVT_KEY:
//            TAP_Print("\nEVT_KEY, event=%x, param1=%x, param2=%x", event, param1, param2);
                TAP_GetState(&state, &subState);
//            TAP_Print("\nEVT_KEY, state=%x, subState=%x", state, subState);

            param1 = on_keypress(param1);

            if (menu_enable) {
                if (main_menu.visible) {
                    param1 = main_menu_handler(&main_menu, param1);
                }
                else
                if ((state == STATE_Normal) && (subState == SUBSTATE_Normal)) {
                    param1 = key_handler(param1);
                }
            }
            break;

        default:
//            TAP_Print("\nEVT_???, event=%x, param1=%x, param2=%x", event, param1, param2);
            break;
    }
    return param1;
}

int main_menu_handler(type_menu *menu, dword param1)
{
    int selection;

    switch (param1) {
        case RKEY_Ok:
            selection = TAP_Win_GetSelection(&menu->win);
            DeleteMenu(menu);
            TAP_EnterNormal();
            switch (selection) {
                case 0:
                    remote_status();
                    return 0;

                case 1:
                    close();
                    TAP_Exit();
                    return 0;
            }
            break;
        case RKEY_Exit:
            DeleteMenu(menu);
            TAP_EnterNormal();
            return 0;
        default:
            if (param1 == menu_key) {
                 DeleteMenu(menu);
                 TAP_EnterNormal();
                 return param1;
            }
            TAP_Win_Action(&menu->win, param1);
            return 0;
    }
    return param1;
}

int key_handler(dword param1)
{
    if (param1 == menu_key) {
        //only if tsrcommander is not running
        if (!is_tsr_commander_running()) {
            TAP_ExitNormal();
            ShowMenu(&main_menu);
            return 0;
        }
    }
    return param1;
}

//----------------------------------------------------------------------------
int set_fw_addresses()
{
    if (fw_sysid == 456) {
        switch(_appl_version) {
            case 0x1409:
                fw_AVMatrixWriteRegister = (void *)0x800b030c;
                fw_AVMatrixReadRegister  = (void *)0x800b04e4;
                fw_set_tv_slow_blanking  = (void *)0x800890e4;                   //[0=4:3, 1=16:9]
                fw_task_e300             = (void *)0x80109894;
                fw_wssmode               = (volatile byte *)(fw_gp-0x6507);      //[0=4:3, 1=16:9]
                fw_av_stb                = (volatile byte *)(fw_gp-0x620c);      //0=vid, 1=pass-through
                fw_av_matrix0            = (volatile byte *)(fw_gp-0x64e8);      //shadow copy of av_matrix registers
                fw_av_matrix1            = fw_av_matrix0 + 1;
                fw_av_matrix2            = fw_av_matrix0 + 2;
                fw_av_matrix3            = fw_av_matrix0 + 3;
                fw_av_matrix4            = fw_av_matrix0 + 4;
                fw_av_matrix5            = fw_av_matrix0 + 5;
                break;
            case 0x1408:
                fw_AVMatrixWriteRegister = (void *)0x800b030c;
                fw_AVMatrixReadRegister  = (void *)0x800b04e4;
                fw_set_tv_slow_blanking  = (void *)0x800890e4;                   //[0=4:3, 1=16:9]
                fw_task_e300             = (void *)0x80109830;
                fw_wssmode               = (volatile byte *)(fw_gp-0x6507);      //[0=4:3, 1=16:9]
                fw_av_stb                = (volatile byte *)(fw_gp-0x620c);      //0=vid, 1=pass-through
                fw_av_matrix0            = (volatile byte *)(fw_gp-0x64e8);      //shadow copy of av_matrix registers
                fw_av_matrix1            = fw_av_matrix0 + 1;
                fw_av_matrix2            = fw_av_matrix0 + 2;
                fw_av_matrix3            = fw_av_matrix0 + 3;
                fw_av_matrix4            = fw_av_matrix0 + 4;
                fw_av_matrix5            = fw_av_matrix0 + 5;
                break;
            case 0x1340:
                fw_AVMatrixWriteRegister = (void *)0x800aec6c;
                fw_AVMatrixReadRegister  = (void *)0x800aee44;
                fw_set_tv_slow_blanking  = (void *)0x800884c0;
                fw_task_e300             = (void *)0x80108048;
                fw_wssmode               = (volatile byte *)(fw_gp-0x657f);      //[0=4:3, 1=16:9]
                fw_av_stb                = (volatile byte *)(fw_gp-0x6293);      //0=vid, 1=pass-through
                fw_av_matrix0            = (volatile byte *)(fw_gp-0x6560);      //shadow copy of av_matrix registers
                fw_av_matrix1            = fw_av_matrix0 + 1;
                fw_av_matrix2            = fw_av_matrix0 + 2;
                fw_av_matrix3            = fw_av_matrix0 + 3;
                fw_av_matrix4            = fw_av_matrix0 + 4;
                fw_av_matrix5            = fw_av_matrix0 + 5;
                break;
            case 0x1365:
                fw_AVMatrixWriteRegister = (void *)0x800af134;
                fw_AVMatrixReadRegister  = (void *)0x800af30c;
                fw_set_tv_slow_blanking  = (void *)0x80088898;
                fw_task_e300             = (void *)0x8010889c;
                fw_wssmode               = (volatile byte *)(fw_gp-0x657f);      //[0=4:3, 1=16:9]
                fw_av_stb                = (volatile byte *)(fw_gp-0x628b);      //0=vid, 1=pass-through
                fw_av_matrix0            = (volatile byte *)(fw_gp-0x6560);      //shadow copy of av_matrix registers
                fw_av_matrix1            = fw_av_matrix0 + 1;
                fw_av_matrix2            = fw_av_matrix0 + 2;
                fw_av_matrix3            = fw_av_matrix0 + 3;
                fw_av_matrix4            = fw_av_matrix0 + 4;
                fw_av_matrix5            = fw_av_matrix0 + 5;
                break;
            default:
                return -1;
        }
        //save the original
        if (*(dword *)((dword)fw_set_tv_slow_blanking+4)) {
            patch_set_tv_slow_blanking[0] = *(dword *)((dword)fw_set_tv_slow_blanking+0);
            patch_set_tv_slow_blanking[1] = *(dword *)((dword)fw_set_tv_slow_blanking+4);
        }
        else {
            patch_set_tv_slow_blanking[0] = 0;
            patch_set_tv_slow_blanking[1] = 0;
        }

        //do [Cp] - ClickPush
        if (fw_key_map_patch == 0) return -1;
        patch_click_push[0] = *(dword *)((dword)fw_key_map_patch-0x24);     //801331cc: 57 00 00 30   bnezl $t8, 0x30       -->nop
        patch_click_push[1] = *(dword *)((dword)fw_key_map_patch-0x20);     //801331d0: 8f bf 00 24   lw    $ra, 0x24($sp)  -->nop
        *(dword *)((dword)fw_key_map_patch-0x24) = 0;
        *(dword *)((dword)fw_key_map_patch-0x20) = 0;

        return 0;
    }
    return -1;
}

//----------------------------------------------------------------------------
//
//
//
dword rc_csum(dword x)
{
    return (((x>>24)&0xff) + ((x>>16)&0xff) + ((x>>8)&0xff) + ((x>>0)&0xff) - 1) & 0xff;
}

void set_remote(int remote_id)
{
    dword param[4];

    if (remote_id < 0) return;
    if (remote_id > 3) return;

    param[0] = 0x0c;
    param[1] = ((remote_id == 0) ? 0x10000000 : 0) | 0x00000000 | remote0;
    param[2] = rc_csum(param[1]) << 24;
    exTAP_CallFirmware((void *)fw_ioctl, 0x00, (dword)param, 0,0,0,0,0,0,0,0,0);
    if (debug) printf("\nset remote0 = %02x %08x %08x", param[0], param[1], param[2]);

    param[0] = 0x0c;
    param[1] = ((remote_id == 1) ? 0x10000000 : 0) | 0x01000000 | remote1;
    param[2] = rc_csum(param[1]) << 24;
    exTAP_CallFirmware((void *)fw_ioctl, 0x00, (dword)param, 0,0,0,0,0,0,0,0,0);
    if (debug) printf("\nset remote1 = %02x %08x %08x", param[0], param[1], param[2]);

    param[0] = 0x0c;
    param[1] = ((remote_id == 2) ? 0x10000000 : 0) | 0x02000000 | remote2;
    param[2] = rc_csum(param[1]) << 24;
    exTAP_CallFirmware((void *)fw_ioctl, 0x00, (dword)param, 0,0,0,0,0,0,0,0,0);
    if (debug) printf("\nset remote2 = %02x %08x %08x", param[0], param[1], param[2]);

    param[0] = 0x0c;
    param[1] = ((remote_id == 3) ? 0x10000000 : 0) | 0x03000000 | remote3;
    param[2] = rc_csum(param[1]) << 24;
    exTAP_CallFirmware((void *)fw_ioctl, 0x00, (dword)param, 0,0,0,0,0,0,0,0,0);
    if (debug) printf("\nset remote3 = %02x %08x %08x", param[0], param[1], param[2]);
}
//----------------------------------------------------------------------------

//
//monitor the slow blanking input (pin 8) on the comms_scart
//0x=low, 10=5v=16:9, 11=10v=4:3
//
void one_second_update(void)
{
    dword tick;
    dword scart_active;
    dword slow_blanking;
    byte av_stb;
    dword param[4];

    scart_active = (comms_scart == COMMS_SCART_VCR) ? 8 : 2;
    slow_blanking = exTAP_CallFirmware(fw_AVMatrixReadRegister, 0,0,0,0,0,0,0,0,0,0,0);
    av_stb = *fw_av_stb;      //0=vid, 1=pass-through
//  if (debug) printf("\nactive=%x, av_stb=%x-%s, slow blanking=%02x-vcr:%s, tv:%s",
//        active,
//        av_stb,
//        (av_stb) ?"pass through" :  "output",
//        slow_blanking,
//        ((slow_blanking & 0x0c) == 0xc)?"4:3" :
//        ((slow_blanking & 0x0c) == 0x8)?"16:9" :
//        ((slow_blanking & 0x0c) == 0x4)?"low" : "???",
//        ((slow_blanking & 0x03) == 0x3)?"4:3" :
//        ((slow_blanking & 0x03) == 0x2)?"16:9" :
//        ((slow_blanking & 0x03) == 0x1)?"low" : "???");

    if (comms_dir==COMMS_DIR_INPUT) { //input
        if (active) {
            //if pin8 is high, something is coming in the comms_scart, switch us off
            if (slow_blanking & scart_active) {
                if (tv_scart_mode == TV_SCART_MODE_PASSTHROUGH) {
                    //set to passthrough vcr scart to tv scart
//                    if (av_stb==0) exTAP_CallFirmware((void *)fw_add_task_queue, 0xe300, RKEY_TvSTB, 0,0,0,0,0,0,0,0,0);
//                    if (av_stb==0) exTAP_CallFirmware((void *)fw_task_e300, 0xe300, RKEY_TvSTB, 0,0,0,0,0,0,0,0,0);

                    if (av_stb==0) {
                        *fw_av_stb = 1;  //0=vid, 1=pass-through
                        param[0] = 4;
                        param[1] = 3;
//                        ioctl(8,4,3)-passthrough
                        exTAP_CallFirmware((void *)fw_ioctl, 8, (dword)param, 0,0,0,0,0,0,0,0,0);
                    }
                }
                //disable the remote
                active = 0;
                //warn the user if he is still seeing a picture
                TAP_ExitNormal();
                xyprintf(50, 50, "%s Remote Inactive", box_name);
            }
        }
        else {
            //if pin8 is low, nothing is coming in the vcr scart, switch us on
            if ((slow_blanking & scart_active) == 0) {
                if (tv_scart_mode == TV_SCART_MODE_PASSTHROUGH) {
                    //clear the passthrough, drive the tv scart
//                    if (av_stb) {
////                        exTAP_CallFirmware((void *)fw_add_task_queue, 0xe300, RKEY_TvSTB, 0,0,0,0,0,0,0,0,0);
//                        exTAP_CallFirmware((void *)fw_task_e300, 0xe300, RKEY_TvSTB, 0,0,0,0,0,0,0,0,0);
//                        //the firmware always leaves it in 4:3, so try to fix it [0=4:3, 1=16:9]
//                        exTAP_CallFirmware(fw_set_tv_slow_blanking, (dword)*fw_wssmode, 0,0,0,0,0,0,0,0,0,0);
//                    }
                    if (av_stb==1) {
                        *fw_av_stb = 0;  //0=vid, 1=pass-through
                        param[0] = 4;
                        param[1] = 1;
//                        ioctl(8,4,1)-4:3
                        exTAP_CallFirmware((void *)fw_ioctl, 8, (dword)param, 0,0,0,0,0,0,0,0,0);
                        //the firmware always leaves it in 4:3, so try to fix it [0=4:3, 1=16:9]
                        exTAP_CallFirmware(fw_set_tv_slow_blanking, (dword)*fw_wssmode, 0,0,0,0,0,0,0,0,0,0);
                    }
                }
                //enable the remote
                active = 1;
                //welcome back the user
                TAP_ExitNormal();
                xyprintf(50, 50, "%s", box_name);
                message_showing = 0xffffffff;
                tick = TAP_GetTick();
                stb_timeout = tick+300;
            }
        }
    }
}

//
//
int on_keypress(int param1)
{
    dword tick;
    dword state, subState;
    byte slow_blanking;

    TAP_GetState(&state, &subState);
//  if (debug) printf("\nstate=%x, subState=%x, param1=%x, stb_state=%x, active=%x", state, subState, param1, stb_state, active);

//    if (box_id==1) {
    if (comms_dir==COMMS_DIR_INPUT) {
        if (active) {
            //suppress tv_stb
            if (param1 == RKEY_TvSTB) {
                if ((state == STATE_Normal) && (subState == SUBSTATE_Normal)) {
                    TAP_ExitNormal();
                    xyprintf(50, 50, "%s", box_name);
                    message_showing = 0xffffffff;
                    tick = TAP_GetTick();
                    stb_timeout = tick+300;
                }
                param1 = 0;
            }
        }
        else {
            if (param1 & KEY_Flag_Click) return 0;
            if ((state == STATE_Normal) && (subState == SUBSTATE_Normal)) {
                TAP_ExitNormal();
                xyprintf(50, 50, "%s Remote Inactive", box_name);
remote_status();
            }
            //suppress everything
            param1 = 0;
        }
        return param1;
    }


//    if (box_id==2) {
    if (comms_dir==COMMS_DIR_OUTPUT) {
        //if inactive, only care about RKEY_TvSTB
        if (active == 0) {
            if (param1 == RKEY_TvSTB) {
            }
            else {
                if (param1 & KEY_Flag_Click) return 0;
                if ((state == STATE_Normal) && (subState == SUBSTATE_Normal)) {
                    TAP_ExitNormal();
                    xyprintf(50, 50, "%s Remote Inactive", box_name);
remote_status();
                }
                return 0;
            }
        }

        //1st press - status
        //2nd press, before timeout - change stb
        //
        if (param1 == RKEY_TvSTB) {
            tick = TAP_GetTick();
            switch (stb_state) {
                case 0:
                    if ((state == STATE_Normal) && (subState == SUBSTATE_Normal)) {
                        //1st press - status
                        TAP_ExitNormal();
                        xyprintf(50, 50, "%s", box_name);
                        message_showing = 0xffffffff;
                        stb_timeout = tick+300;
                        stb_state = 1;
                    }
                    break;

                case 1:
                    //2nd press, before timeout - change stb
                    if (active) {
                        //suppress tv_stb, disable scart, disable remote

                        if (comms_scart == COMMS_SCART_TV) {
                            //inhibit further blanking changes by firmware
                            if (patch_set_tv_slow_blanking[1]) {
                                *(dword *)((dword)fw_set_tv_slow_blanking+0) = 0x03e00008;  //03 e0 00 08   jr $ra
                                *(dword *)((dword)fw_set_tv_slow_blanking+4) = 0x00000000;  //00 00 00 00   nop
                            }

                            //if toppy_output == tv_scart
                            slow_blanking = *fw_av_matrix5;
                            slow_blanking = slow_blanking & 0xcf;
                            slow_blanking = slow_blanking | 0x10;
                        }
                        else {
                            //if toppy_output == vcr_scart
                            slow_blanking = *fw_av_matrix5;
                            slow_blanking = slow_blanking & 0x3f;
                            slow_blanking = slow_blanking | 0x40;
                        }
                        *fw_av_matrix5 = slow_blanking;
                        exTAP_CallFirmware(fw_AVMatrixWriteRegister, 5, (dword)slow_blanking, 0,0,0,0,0,0,0,0,0);
                        active = 0;
                    }
                    else {
                        if (comms_scart == COMMS_SCART_TV) {
                            //ensure blanking patch is cleared
                            if (patch_set_tv_slow_blanking[1]) {
                                *(dword *)((dword)fw_set_tv_slow_blanking+0) = patch_set_tv_slow_blanking[0];   //27 BD FF E0   addiu $sp, -0x20
                                *(dword *)((dword)fw_set_tv_slow_blanking+4) = patch_set_tv_slow_blanking[1];   //AF B5 00 14   sw    $s5, 0x14($sp)
                            }

                            //enable tv scart out, try to get the aspect ratio right, enable remote
                            slow_blanking = *fw_av_matrix5;
                            slow_blanking = slow_blanking & 0xcf;
                            exTAP_update_aspect_ratio();
                            if (fw_aspect[CHANNEL_Main].ratio==2) { //ASPECT_4_3
                                slow_blanking = slow_blanking | 0x30;
                            }
                            else {
                                slow_blanking = slow_blanking | 0x20;
                            }
                        }
                        else {
                            //enable tv scart out, try to get the aspect ratio right, enable remote
                            slow_blanking = *fw_av_matrix5;
                            slow_blanking = slow_blanking & 0x3f;
                            exTAP_update_aspect_ratio();
                            if (fw_aspect[CHANNEL_Main].ratio==2) { //ASPECT_4_3
                                slow_blanking = slow_blanking | 0xc0;
                            }
                            else {
                                slow_blanking = slow_blanking | 0x80;
                            }
                        }
                        *fw_av_matrix5 = slow_blanking;
                        exTAP_CallFirmware(fw_AVMatrixWriteRegister, 5, (dword)slow_blanking, 0,0,0,0,0,0,0,0,0);
                        active = 1;
                        TAP_ExitNormal();
                        xyprintf(50, 50, "%s", box_name);
                        message_showing = 0xffffffff;
                    }
                    //inhibit for a while
                    stb_timeout = tick+300;
                    stb_state = 2;
                    break;

                case 2:
                    //inhibited
                    break;
            }
            param1 = 0;
        }
    }

    return param1;
}

//----------------------------------------------------------------------------
void remote_status(void)
{
    byte av_stb;
    int slow_blanking;
    type_etc_structure *etc;
    dword tick;

    slow_blanking = exTAP_CallFirmware(fw_AVMatrixReadRegister, 0,0,0,0,0,0,0,0,0,0,0);
    av_stb = *fw_av_stb;      //0=vid, 1=pass-through
    etc = (type_etc_structure *)*(dword *)fw_etc_structure;

    if (debug) {
        printf("\nbox_id                 : %d", box_id);
        printf("\nbox_name               : %s", box_name);
        printf("\nactive                 : %d", active);
        printf("\ncomms_scart            : %d", comms_scart);
        printf("\ncomms_dir              : %d", comms_dir);
        printf("\ntv_scart_mode          : %d", tv_scart_mode);
        printf("\nvcr_scart_mode         : %d", vcr_scart_mode);
        printf("\nmenu_enable            : %d", menu_enable);
        printf("\nmenu_key               : %x", menu_key);
        printf("\ndebug                  : %x", debug);
        printf("\nsplash_enable          : %d", splash_enable);

        printf("\n");
        printf("\nav_matrix - STV6412A");
        printf("\n    av_0               : %02x", *fw_av_matrix0);
        printf("\n    av_1               : %02x", *fw_av_matrix1);
        printf("\n    av_2               : %02x", *fw_av_matrix2);
        printf("\n    av_3               : %02x", *fw_av_matrix3);
        printf("\n    av_4               : %02x", *fw_av_matrix4);
        printf("\n    av_5               : %02x", *fw_av_matrix5);
        printf("\nslow_blanking          : %02x, vcr:%s, tv:%s",
            slow_blanking,
            ((slow_blanking & 0x0c) == 0xc)?"4:3" :
            ((slow_blanking & 0x0c) == 0x8)?"16:9" :
            ((slow_blanking & 0x0c) == 0x4)?"low" : "???",
            ((slow_blanking & 0x03) == 0x3)?"4:3" :
            ((slow_blanking & 0x03) == 0x2)?"16:9" :
            ((slow_blanking & 0x03) == 0x1)?"low" : "???"
        );

        printf("\n");
        printf("\nav_stb                 : %02x, %s",
            av_stb,
            (av_stb) ?"pass through" :  "output"
        );
        printf("\nwss mode               : %s", (*fw_wssmode) ? "16:9" : "4:3");

        printf("\n");
        printf("\netc");
        printf("\netc->byte_0b           : %02x", etc->byte_0b);
        printf("\n    Scart Output Source: %x", (etc->byte_0b >> 3) & 3);
        printf("\netc->byte_13           : %02x", etc->byte_13);
        printf("\n    Scart Type         : %x", (etc->byte_13 >> 5) & 1);
    }

    TAP_ExitNormal();
    xyprintf(200, 400, "box_id: %d, box_name: %s\nscart mode: %s\nvcr scart: %s\ntv  scart: %s",
        box_id, box_name,
        (av_stb) ?"pass through" :  "output",
        ((slow_blanking & 0x0c) == 0xc)?"4:3" :
        ((slow_blanking & 0x0c) == 0x8)?"16:9" :
        ((slow_blanking & 0x0c) == 0x4)?"low" : "???",
        ((slow_blanking & 0x03) == 0x3)?"4:3" :
        ((slow_blanking & 0x03) == 0x2)?"16:9" :
        ((slow_blanking & 0x03) == 0x1)?"low" : "???"
    );


    message_showing = 0xffffffff;
    tick = TAP_GetTick();
    stb_timeout = tick+300;
}

/*
av_matrix - STV6412A
0, 0x00     0x00    audio   - stereo, 0dB, 0dB, soft                                                           lbu     $t9, -0x64E8($gp)
1, 0x19     0x22    audio   - stereo,encoderL/R,tv_gain,encoderL/R              stereo,tvL/R,0dB,vcrL/R        lbu     $t8, -0x64E7($gp)
2, 0x92     0x33    video   - cvbs_enc, yc_enc                                  tv_mute,cvbs_vcr               lbu     $t7, -0x64E6($gp)
3, 0xd5     0xfb    video   - +3dB,+5dB,rgb_enc,fb_high                         +3dB,+3dB,rgb_vcr,fb_vcr       lbu     $t9, -0x64E5($gp)
4, 0x10     0x50    misc    - sb_norm, vcr_active                               sb_vcr, vcr_active             lbu     $t9, -0x64E4($gp)
5, 0x38     0x00    misc    -                                                   4:3                            lbu     $t7, -0x64E3($gp)
6,                  stbby

read
xxxx_vcr_tv
*/
//----------------------------------------------------------------------------
