#ifndef _TOPFIELD_H_
#define _TOPFIELD_H_
//----------------------------------------------------------------------------
//
//a bunch of topfield firmware specific stuff
//

//----------------------------------------------------------------------------
//
//tap.h extensions
//
#define pLoaderVersion  0xa3fffff8
#define wSysID          0xa3fffffa
extern word fw_sysid;
extern int _appl_version;
extern char *tap_name;

#define ptrfix(p) (p + _tap_startAddr)
typedef void (*funcVoid)(void);
typedef int (*funcInt)(void);
#define is_firmware(p) ((((dword)p&0xfc000000)==0x80000000) ? 1 : 0)

extern int __tap_Header__;
extern int __startPoint;
extern int _initData;
//extern int TAP_Main;
extern int _tap_gotStart;
extern int _tap_gotEnd;
extern int _tap_textEnd;
extern int _tap_fixupStart;
extern int _tap_fixupEnd;
//extern int TAP_EventHandler;
extern int _gp;
extern int _end;
//----------------------------------------------------------------------------
//
//local key defines (missing in key.h)
//
#define RKEY_TvSTB      0x10022       //was RKEY_TvSat
#define RKEY_Opt        0x10010

#define RKEY_List       0x10018       //shared with RKEY_TvRadio

#define RKEY_Right      0x10015       //shared with RKEY_VolUp
#define RKEY_Left       0x1000f       //shared with RKEY_VolDown
#define RKEY_Up         0x10012       //shared with RKEY_ChUp
#define RKEY_Down       0x1001d       //shared with RKEY_ChDown

#define RKEY_SubMove    0x10041
#define RKEY_FileList   0x10042       //or RKEY_PlayList
#define RKEY_Text       0x10043

#define RKEY_Red        0x1003f
#define RKEY_Green      0x10024
#define RKEY_Yellow     0x10025
#define RKEY_Blue       0x10026

#define RKEY_White      0x1003e
#define RKEY_SubSwap    0x10040

//unmapped key values
#define exRKEY_TvRadio  0x1000e       //0x10018 (RKEY_List)    remapped to 0x1000e (RKEY_Uhf)
#define exRKEY_Exit     0x10013       //0x10017 (RKEY_VolDown) remapped to 0x10013 (RKEY_AudioTrk)

#define exRKEY_VolUp    0x10020       //0x10015 (RKEY_Right)   remapped to 0x10020 (RKEY_Fav )
#define exRKEY_VolDown  0x10017       //0x1000f (RKEY_Left)    remapped to 0x10017 (RKEY_Exit)
#define exRKEY_ChUp     0x10021       //0x10012 (RKEY_Up)      remapped to 0x10021 (RKEY_Subt)
#define exRKEY_ChDown   0x10037       //0x1001d (RKEY_Down)    remapped to 0x10037 (RKEY_Teletext)

#define FKEY_AVMenu     0xff001       //a/v output setting menu
#define FKEY_Sleep      0xff002       //sleep toggle
#define FKEY_SoundMenu  0xff003       //sound track menu
#define FKEY_FavMenu    0xff004       //favourite menu
#define FKEY_SubtitleMenu 0xff005     //subtitle track menu
#define FKEY_0006         0xff006     //???
#define FKEY_PIPBackward  0xff007     //move pip backwards
#define FKEY_PIPForward   0xff008     //move pip
#define FKEY_SetBookmark  0xff009     //set bookmark
#define FKEY_GotoBookmark 0xff00a     //goto bookmark
//----------------------------------------------------------------------------
//hdd.h extensions
#ifndef ATTR_NORMAL
#define ATTR_NORMAL 	0xd0
#endif
#ifndef ATTR_TS
#define ATTR_TS 		0xd1
#endif
#ifndef ATTR_PROGRAM
#define ATTR_PROGRAM	0xd2
#endif
#ifndef ATTR_DOTDOT
#define ATTR_DOTDOT 	0xf0
#endif
#ifndef ATTR_DOT
#define ATTR_DOT        0xf1
#endif
#ifndef ATTR_FOLDER
#define ATTR_FOLDER 	0xf2
#endif
#ifndef ATTR_RECYCLE
#define ATTR_RECYCLE 	0xf3
#endif
//----------------------------------------------------------------------------
//
//see en300 468
//1st char of string <0x20, change character set
//
#define ESC_8a              "\x8a"      //          //cr/lf
#define ESC_90              "\x90"      //""       //[nn] extended char, nn=0-46
#define ESC_91              "\x91"      //""       //[nn] make foreground transparent

#define OSD_RIGHT0          "\x90[0]"
#define OSD_LEFT_RIGHT      "\x90[1]"
#define OSD_UP_DOWN         "\x90[2]"
#define OSD_OK              "\x90[3]"
#define OSD_EXIT            "\x90[4]"
#define OSD_MENU            "\x90[5]"
#define OSD_LEFT1           "\x90[6]"
#define OSD_RIGHT1          "\x90[7]"
#define OSD_UP1             "\x90[8]"
#define OSD_DOWN1           "\x90[9]"

#define OSD_LEFT2           "\x90[10]"
#define OSD_RIGHT2          "\x90[11]"
#define OSD_UP2             "\x90[12]"
#define OSD_DOWN2           "\x90[13]"
#define OSD_TV              "\x90[14]"
#define OSD_MUTE1           "\x90[15]"
#define OSD_MUTE2           "\x90[16]"
#define OSD_MUTE3           "\x90[17]"
#define OSD_ENCRYPTED       "\x90[18]"
#define OSD_RADIO           "\x90[19]"

#define OSD_TICK            "\x90[20]"
#define OSD_HALF            "\x90[21]"
#define OSD_FULL            "\x90[22]"
#define OSD_RED_SQUARE      "\x90[23]"
#define OSD_DOLLAR          "\x90[24]"
#define OSD_RED             "\x90[25]"
#define OSD_GREEN           "\x90[26]"
#define OSD_YELLOW          "\x90[27]"
#define OSD_BLUE            "\x90[28]"
#define OSD_WHITE           "\x90[29]"

#define OSD_INFO            "\x90[30]"
#define OSD_REWIND          "\x90[31]"
#define OSD_PLAY            "\x90[32]"
#define OSD_PAUSE           "\x90[33]"
#define OSD_FORWARD         "\x90[34]"
#define OSD_SLOW            "\x90[35]"
#define OSD_STOP            "\x90[36]"
#define OSD_RECORD          "\x90[37]"
#define OSD_CENTRE          "\x90[38]"
#define OSD_DOLBY           "\x90[39]"

#define OSD_MULTI           "\x90[40]"
#define OSD_DECRYPTED       "\x90[41]"
#define OSD_EURO            "\x90[42]"
#define OSD_OPT             "\x90[43]"
#define OSD_SAT             "\x90[44]"
#define OSD_W               "\x90[45]"
#define OSD_ST              "\x90[46]"
//any more crash

//----------------------------------------------------------------------------
//
//this is the internal data structure used to store events
//it _always_ starts at address FW_EVENT_TABLE
//what are the unknown values ???
//how is the event_name, extended_event_name allocated ???
//note that the extended_event_name is a list of (num_extended) zero terminated (name,description) pairs
//with a total length of extended_length  The final pair is terminated with another 0 (i.e. 2 0's indicate end of list)
//
typedef struct{
    byte  char00;                   //00    //for 1288: top 2 bits = valid, next 3 bits = running status, next 3 = ???
//    byte  char00a:2;                //00
//    byte  running_status:3;         //00
//    byte  char00b:3;                //00
    byte  char01;                   //01
    byte  duration_hour;            //02
    byte  duration_min;             //03
    word  short04;                  //04    //??? normally 0000
    word  event_id;                 //06
    word  start_date;               //08    //mjd, utc time
    byte  start_hour;               //0a
    byte  start_min;                //0b
    word  end_date;                 //0c    //mjd, utc time
    byte  end_hour;                 //0e
    byte  end_min;                  //0f
    byte  event_name_length;        //10
    byte  parental_rating;          //11
    word  original_network_id;      //12
    word  transport_stream_id;      //14
    word  service_id;               //16
    word  short18;                  //18    //??? normally 0000
    word  sat_index;                //1a
    word  short1c;                  //1c    //??? normally 0000
    byte  desc_lang;                //1e    //??? normally 00 or 65 (1st byte ISO639 lang = "short desc rec?")
    byte  byte1f;                   //1f    //??? normally 00
    word  short20;                  //20    //??? normally 0000
    word  previous;                 //22    //previous, a link to the previous epg entry, by date/time, ffff terminates
    word  short24;                  //24    //??? normally 0000
    word  next;                     //26    //next, a link to the previous epg entry, by date/time, ffff terminates
    byte  *event_name;              //28    //ptr to event name, event description is offset by event_name_length bytes
//for >=1288, event fields reordered
    union {
        //<12.88
        struct{
            byte  ext_present;              //2c    //01 if extended present else 00
            byte  num_extended;             //2d    //number of extended items
            word  extended_length;          //2e    //extended length
            byte  *extended_event_name;     //30
        }fw;
        //>=12.88
        struct{
            byte  *extended_event_name;     //2c
            byte  ext_present;              //30    //01 if extended present else 00
            byte  num_extended;             //31    //number of extended items
            word  extended_length;          //32    //extended length
        }fw13;
    }event;
    word  short34;                  //34    //0001 if extended present else 0000   extDescLen
    word  short36;                  //36    //0001 if extended present else 0000   sharedText (str alloced elsewhere), extNumDescrs
    word  date_added;               //38    //mjd, utc time - date added ?         extLastDescrNum, extLangMatch
    word  short3a;                  //3a    //??? normally 0000                    dateAdded
    word  short3c;                  //3c    //??? normally 0000                    ---
    word  short3e;                  //3e    //??? normally 0000

//for >=1288, eventtable is 0x44 long, genre
//for >=1400, genre moves
    union {
        //<14.02
        struct{
            byte  content_nibble1;          //40
            byte  content_nibble2;          //41
            word  short42;                  //42    //user_nibble1,2? - not filled in by fw?
        }fw13;
        //>=1402
        struct{
            word  short40;                  //40            //0000                 EVTUNK1 (-1)
            word  short42;                  //42            //0000
        }fw14;
    }genre;

//for >=1400, eventtable is 0x64 long, crid
    byte  content_nibble1;          //44
    byte  content_nibble2;          //45

    byte  crid32_strlen;            //46    //crid32 strlen (series)
    byte  byte47;                   //47
    byte *crid32_str;               //48    //crid32 ptr string
    byte  crid31_strlen;            //4c    //crid31 strlen (repeat)
    byte  byte4d;                   //4d
    byte  byte4e;                   //4e
    byte  byte4f;                   //4f
    byte *crid31_str;               //50    //crid31 ptr string
    byte  crid33_strlen;            //54    //crid33 strlen (recomendation?)
    byte  byte55;                   //55
    byte  byte56;                   //56
    byte  byte57;                   //57
    byte *crid33_str;               //58    //crid33 ptr string

    dword  dword5c;                 //5c                                            //00000000
    dword  dword60;                 //60                                            //00000000
//14.06
  dword  dword64;                 //64
}type_eventtable;

//----------------------------------------------------------------------------
//
//this is the internal table that holds pointers to the event name/description buffers
//
//note, from 1288, only the first buffer is used for both short and extended data
//
typedef struct {
    byte *short_event_buffer;
    dword short_event_blocks;
    dword s2;
    dword s3;
    byte *extended_event_buffer;
    dword extended_event_blocks;
    dword e2;
    dword e3;
} type_eventbuffer;

//----------------------------------------------------------------------------
typedef struct{
    dword magic;                //00   TFrc
    word  version;              //04   5010    //version
    word  word_ae;              //06   0000
    word  fduration;            //08   0001    //file duration (mins)???
    word  svcNum;               //0a   000d        //lcn   (always 0 )
    word  svcType;              //0c   0000

    word  word_b6;              //0e   0000
    word  word_b8;              //10   04b0        //tuner
    word  service_id;           //12   20fa
    word  pmt_pid;              //14   010e
    word  pcr_pid;              //16   1ffe
    word  video_pid;            //18   024e
    word  audio_pid;            //1a   824f        // | 0x8000
    byte  channel_name[0x1c];   //1c   More 4

    word  uhf_channel;          //30   0016
    byte  bandwidth;            //3a   08
    byte  byte_e3;              //3b   00
    dword frequency;            //3c   00075ad0
    word  transport_stream_id;  //40   2005
    byte  lphp_stream;          //42   00  0=lp,1=hp
    byte  byte_eb;              //43   00
    word  original_network_id;  //44   233a
    word  word_ee;              //46   3005

    word  word_f0;              //48   8000
    word  duration;             //4a   0123     //epg duration hr:min
    word  word_f4;              //4c   0000
    word  event_id;             //4e   793e
    dword startTime;            //50   d2b9151e
    dword endTime;              //54   d2b91705
    byte  runningStatus;        //58   04
    byte  eventName_length;     //59   03
    byte  parental_rating;      //5a   00
    byte  eventName_description[0x100];   //5b GBHThe only ray of ...
    byte  padding[0xf00];       //
}type_rec_header;

//81B57F40
typedef struct{
    byte  playMode;             //00      03, 02                                (0=not, 1=?starting?, 2=play, 3=TS, 4=chase, 5=MP3)
    byte  byte_01;              //01      00          :d[4:3] - recording slots active? (flags)  (bottom bit = oldSvcType)
    byte  byte_02;              //02      00                                    (oldSvcNum[15:0])
    byte  byte_03;              //03      00, 03
    dword trickMode;            //04      00000000                              (0=norm,1=fwd,2=rwd,3=slow,4=pause)
    dword speed;                //08      00000001
    dword dword_0c;             //0c      00000001                              {24'h0, playing[7:0]}

    dword start_time;           //10      start time, (mjd,hr,min)              [file]
    dword dword_14;             //14      03000000                              {(secs)(offset)
    dword dword_18;             //18      00005f2f                              (start_cluster) [unaligned]
    dword dword_1c;             //1c      000000b0                              (total_cluster)
    dword dword_20;             //20      001be800
    byte  filename[0x40];       //24
    byte  channel_name[0x1c];   //64
    dword dword_80;             //80      00000080                              (attributes)
    dword dword_84;             //84      00000000
    dword dword_88;             //88      00000000
    dword dword_8c;             //8c      22000000

    dword dword_90;             //90      82018edc                               (directory)
    dword dword_94;             //94      e812c6ae
    dword dword_98;             //98      00000000
    dword length;               //9c      18201800      //file length(bytes), 64 bit???
    dword dword_a0;             //a0      00000000
    dword dword_a4;             //a4      d87d86b7

    type_rec_header rec;        //a8
}type_play_info;

//0x81C9CF98
typedef struct{
    byte  recType;              //00                                            (tuner_index)
    byte  byte_01;              //01    22,68,          tuner     trickmode     {rec_mode[2:0],demux_path[1:0],manual_reservation[1:0],unused[0:0]}
    byte  byte_02;              //02                    rsvd      speed         (sat_index)
    byte  byte_03;              //03                    svcType                 {service_type[0:0],reservation_type[6:0]}
    word  duration;             //04
    word  chNum;                //06    chnum     ?                             (service_number)
    dword start_time;           //08    start time(mjd,hr,min)
    dword end_time;             //0c    end   time(mjd,hr,min)
    word  word_10;              //10    chtype?                                 {is_rec[7:0], set_name}
    word  service_id;           //12
    char  filename[0x40];       //14                                            [0x50]
    dword dword_54;             //54
    dword dword_58;             //58
    dword dword_5c;             //5c
    dword dword_60;             //60
    word  word_64;              //64                                            {pause, 15'h0}
    word  pmt_pid;              //66
    dword dword_68;             //68
    dword dword_6c;             //6c
    dword dword_70;             //70
    dword dword_74;             //74
    word  uhf_channel;          //78
    byte  bandwidth;            //7a
    byte  byte_7b;              //7b    00
    dword frequency;            //7c
    word  transport_stream_id;  //80
    word  word_82;              //82    0000 ???
    word  original_network_id;  //84
    word  network_id;           //86    3005 ???
}type_rec_info;                 //88


typedef struct{
    word  service_id;           //00
    word  video_pid;            //02
    word  audio_pid;            //04    (|0x8000, top bit set)
    word  pcr_pid;              //06
    word  transport_stream_id;  //08
    word  original_network_id;  //0a
    word  pmt_pid;              //0c
    word  word_0e;              //0e    0018=     0012=
    byte  byte_10;              //10    00
    byte  byte_11;              //11    00            |04
    word  word_12;              //12    0001
}type_channel_info;


typedef struct {
    dword dword_00;             //12.88 dword_612c;  //13.40 dword_611c;   //13.59 dword_6114;
    dword dword_04;             //
    dword dword_08;             //
    dword dword_0c;             //
    dword dword_10;             //    .ts
    dword dword_14;             //    .ts
    dword dword_18;             //    .ts
    dword ts_write_position;    //   .ts/.ss write position (seconds)
    dword dword_20;             //
    dword ts_buffer_length;     //   .ts/.ss buffer length (seconds)
    dword ts_read_offset;       //   .ts/.ss read offset (negative)
    dword dword_2c;             //   .ss position MOD 360 (ev. 10s?)
    dword ss_valid_table;       //   .ss block valid
}type_ts_struct1;

typedef struct {
    dword dword_00;             //12.88 dword_7880;   //13.40 dword_787c;   //13.59 dword_7878;
    dword ts_handle;            //  .ts file handle",
    dword dword_08;             //  .ts        ",
    dword dword_0c;             //  .ts        ",
    dword dword_10;             //  .ts        ",
    dword dword_14;             //  .ts        ",
    dword dword_18;             //  .ts task_id",
    dword ss_handle;            //  .ss file handle",
    dword ss_flag;              //  the recording slot used by timeshft buffer
    dword dword_24;             //  .ts end block",
    dword dword_28;             //  .ss task_id",
    dword dword_2c;             //  .ts end block",
    dword dword_30;             //  .ts 0-7",
}type_ts_struct2;

//----------------------------------------------------------------------------
typedef struct {
    byte  sat_index;
    byte  unused;
    word  transponder_index_flags;
    word  service_id;
    word  pmt_pid;
    word  pcr_pid;
    word  video_pid;
    word  audio_pid;
    byte  flags;
    dword service_name_offset;
    word  provider_index;
    word  lcn;
    byte  unused_10[8];
} type_tv_service_data;

//32
typedef struct {
    word number_of_transponders;
    byte dvbt[4];
    byte unused_4[26];
} type_satellite_table;

//10
typedef struct {
    word channel_number;
    byte bandwidth;
    byte unused_3;
    dword frequency;
    word transport_stream_id;
    byte lp_hp_stream;
    byte unused_b;
    word original_network_id;
    word network_id;
} type_transponder_data;

typedef struct {
    byte name[12];
    word service_index[100];
    byte service_type[100];
    byte number_of_favourites;
    byte unused_139;
} type_favourites;

//44
typedef struct {
    dword money[4];
    dword win[4];
    dword lose[4];
    dword exBlockClearStage;
    byte  reserved[16];
} type_game_data;

//8
typedef struct {
    word utc_offset;
    word sleep_timer;
    byte flags1;
    byte flags2;
    byte flags3;
    byte flags4;
} type_clock_setup;

typedef struct {
    byte tuner;                   //00  tuner
    byte flags;                   //01, d[7:5] = Rec. Mode (0=none, 1=recording, 2=reserved recording, 3=temp. recording, 4=copy)
                                  //    d[4:3] = Demux Channel (?)
                                  //    d[2:1] = Res. Type (1=manual recording (no SID, EventID))
                                  //    d[0]   = unused
    byte satIndex;                //02  ?
    byte mode_reservation;        //03  d[7] = svcType, d[6:0] = reservationType
    word duration;                //04
    word svcNum;                  //06
    dword startTime;              //08
    dword endTime;                //0c
    byte isRec;                   //10
    byte nameFix;                 //11  nameFix setName
    word service_id;              //12
    char fileName[0x40];          //14                       (96=0x60)

    dword dword54;                //54
    word word58;                  //58
    word event_id;                //5a              event_id
    word word5c;                  //5c
    word event_id2;               //5e              event_id
    dword dword60;                //60
    dword dword64;                //64
    dword dword68;                //68
    word service_id3;             //6c              service_id
    word event_id3;               //6e              event_id   of original
    byte crid_valid;              //70      00,01   crid flag  [1=series]
    byte byte71;                  //71
    byte byte72;                  //72      00,02   ???
    byte byte73;                  //73

    //the stucture varies from firmware to firmware
    union {
        //<14.06
        struct{
            word epg_marker;              //74  ?    = 5,           (01)   (02)    2=Rt
            word event_id;                //76

            word channel_number;          //78                      (0019)         (0016)
            byte bandwidth;               //7a                      (08)           (08)
            byte unused_7b;               //7b                      (00)           (00)
            dword frequency;              //7c                      (0007b890)     (00075ad0)
            word transport_stream_id;     //80  ?                   (1004)         (2005)      service_id
            byte lp_hp_stream;            //82
            byte unused_83;               //83
            word original_network_id;     //84  ?                   (233a)         original_network_id
            word network_id;              //86                      (3005)
        }fw13;
        //14.06
        struct{
            dword crid_date;              //74                      (d4970d28)
            byte  crid_str[0x1c];         //78                      (/KCI280)

            word epg_marker;              //94   ?    = 5,          (01)   (02)    2=Rt
            word event_id;                //96

            word channel_number;          //98                      (0019)         (0016)
            byte bandwidth;               //9a                      (08)           (08)
            byte unused_7b;               //9b                      (00)           (00)
            dword frequency;              //9c                      (0007b890)     (00075ad0)
            word transport_stream_id;     //a0   ?                  (1004)         (2005)      service_id
            byte lp_hp_stream;            //a2
            byte unused_83;               //a3
            word original_network_id;     //a4   ?                  (233a)         original_network_id
            word network_id;              //a6                      (3005)
        }fw1406;
        //>14.06
        struct{
            dword crid_date;              //74                      (d4970d28)
            byte  crid31_str[0x1c];       //78                      (/KCI280)       episode_crid(31)

            byte  byte94;                 //94         00
            byte  crid32_str[0x1b];       //95                      (/KCINQ4)       series crid(32)
            dword dwordb0;                //b0         00000000
            dword dwordb4;                //b4         00000000

            word epg_marker;              //b8  ?    = 5,           (01)   (02)    2=Rt
            word event_id;                //ba

            word channel_number;          //bc                      (0019)         (0016)
            byte bandwidth;               //be                      (08)           (08)
            byte unused_7b;               //bf                      (00)           (00)
            dword frequency;              //c0                      (0007b890)     (00075ad0)
            word transport_stream_id;     //c4  ?                   (1004)         (2005)      service_id
            byte lp_hp_stream;            //c6
            byte unused_83;               //c7
            word original_network_id;     //c8  ?                   (233a)         original_network_id
            word network_id;              //ca                      (3005)
        }fw14;
    }fw;

//} type_timer_block_13;        //0x88
//} type_timer_block_1406;        //0xa8
//} type_timer_block_14;        //0xcc
} type_timer_block;        //0xcc

//14.06->a8 ?
//14.07->??
//14.08->cc ?

//
//typedef struct{
//} type_reserve_epg_block;

//typedef struct{
//    word  end_date;                 //06    //mjd
//    word  duration_hour_min;        //08
//    word  duration_hour_min_xx;     //0a  (04)
//    word  event_id;                 //0c
//    byte  end_hour_min;             //0e
//} type_internal_channel_info;


//from 456:14.xx, the number/size of the timer block changes
//so don't rely onthei structure ...
typedef struct {
    //0+4+7d00                                                 14.02
    word crc0;                              //81cf1844         81da478c
    word ffff0;                             //81cf1846         81da478e
    type_tv_service_data tv_service_data[0x3e8];  //81cf1848   81da4790         1000 x 32 type_tv_service_data

    //7d04+4+7d00
    word crc1;                              //81cf9548         81dac490
    word ffff1;                             //81cf954a         81dac492
    type_tv_service_data radio_service_data[0x3e8];  //81cf954c   81dac494      type_tv_service_data

    //fa08+4+20
    word crc2;                              //81d0124c         81db4194
    word ffff2;                             //81d0124e         81db4196
    type_satellite_table satellite_table;   //81d01250         81db4198

    //fa2c+4+ff4                                                transponder
    word crc3;                              //81d01270         81db41b8
    word ffff3;                             //81d01272         81db41ba
    dword number_of_frequencies;            //81d01274         81db41bc         4+0x10 * ???
    type_transponder_data transponder_data[0xff];  //81d01278  81db41c0         0xff x 0x10

    //10a24+4+24cc
    word crc4;                              //81d02268         81db51b0
    word ffff4;                             //81d0226a         81db51b2
    type_favourites favourites[0x1e];       //81d0226c         81db51b4         0x1e x 0x13a

    //12ef4+4+44
    word crc5;                              //81d04738         81db7680
    word ffff5;                             //81d0473a         81db7682
    type_game_data game_data;               //81d0473c         81db7684

    //12f3c+4+8                                                 clock setup
    word crc6;                              //81d04780         81db76c8         73 ac ff ff 00 3c 00 00
    word ffff6;                             //81d04782         81db76ca
    type_clock_setup clock_setup;           //81d04784         81db76cc

    //12f48+4+2530                                             12f48+4+4a60     (140 timers)
    word crc7;                              //81d0478c         81db76d4
    word ffff7;                             //81d0478e         81db76d6
//from 456:14.xx, the number/size of the timer block changes
//so don't rely onthei structure ...
//    type_timer_block timer_block[0x46];     //81d04790         81db76d8         70 x 0x88   type_internal_timerinfo
    type_timer_block timer_block[0x8c];     //81d04790         81db76d8         140 x 0x88   type_internal_timerinfo          !!!!!!!!

    //1547c+4+230                                              179ac+4+230
    word crc8;                              //81d06cc0         81dbc138
    word ffff8;                             //81d06cc2         81dbc13a
    byte reserveepg[0x230];                 //81d06cc4         81dbc13c         reserveepg

    //156b0+4+fde8                                             17be0+4+fde8
    word crc9;                              //81d06ef4         81dbc36c
    word ffff9;                             //81d06ef6         81dbc36e
    byte channel_names[0xfde8];             //81d06ef8         81dbc370         81dbc70c          char

    //2549c+4+1500                                             279cc+4+1500    81dc1cfc
    word crc10;                             //81d16ce0         81dcc158          81dc9c28
    word ffff10;                            //81d16ce2         81dcc15a          81dc9c2a
    byte provider_names[0x15][0x100];       //81d16ce4         81dcc15c          81dc9c2c        char        21 x 0x100

    //269a0+4+d9a8
    word crc11;                             //81d181e4          ffff
    word ffff11;                            //81d181e6
    byte ota[0xd9a8];                       //81d181e8
} type_flash;

//----------------------------------------------------------------------------
typedef struct {
    word    mjd;
    byte    hour;
    byte    minute;
}type_taptime;

typedef struct {
    int afd;
    int horizontal_size;
    int vertical_size;
    int ratio;
    int frame_rate;
    int bit_rate;
} type_aspect;
//----------------------------------------------------------------------------
//
//tap load structures
//
typedef struct
{
    byte signature[32];					//TFAMIPS
    dword id;
    byte padding1[28];
    const char name[MAX_PROGRAM_NAME];
    const char authorName[MAX_AUTHOR_NAME];
    const char description[MAX_DESCRIPTION];
    const char etcStr[MAX_ETCINFO_STR];
} type_TAPHeader;

typedef struct
{
    // From libtap.a                                               12.88
    dword _initData;                                      //  00   827b37c4
    void *TAP_Main;                                       //  04   827a8b68
    dword _tap_gotStart;                                  //  08   00020be0
    dword _tap_gotEnd;                                    //  0c   000210f4
    dword _tap_textEnd;                                   //  10   0000c970
    dword _tap_fixupStart;                                //  14   000210ec
    dword _tap_fixupEnd;                                  //  18   000210f0
    void *TAP_EventHandler;                               //  1c   827a8d30
    dword _gp;                                            //  20   00020be0
    dword _end;                                           //  24   000246c0
                                                          //
    void *pTAP_SystemProc;                                //  28   80177a54
    void *_appl_version;                                  //  2c   00001288
    void *null30;                                         //  30   00000000
    void *pTAP_GetState;                                  //  34   801779a4
    void *pTAP_ExitNormal;                                //  38   80177684
    void *pTAP_EnterNormal;                               //  3c   80177720
    void *null40;                                         //  40   00000000
    void *null44;                                         //  44   00000000
    void *pTAP_Exit;                                      //  48   801777ac
    void *pTAP_KbHit;                                     //  4c   80177278
    void *pTAP_GetCh;                                     //  50   8017730c
    void *pTAP_PutCh;                                     //  54   801773a0
    void *pTAP_Print;                                     //  58   80177538
    void *pTAP_GetSystemProc;                             //  5c   8018117c
    void *pTAP_TAP_SysOsdControl;                         //  60   80181208
    void *pTAP_SetBaudRate;                               //  64   801813a4
    void *pTAP_PutByte;                                   //  68   8017742c
    void *pTAP_PrintSys;                                  //  6c   80177494
    //etc
    void *null70;                                         //  70   00000000
    void *null74;                                         //  74   00000000
    void *null78;                                         //  78   00000000
    void *null7c;                                         //  7c   00000000
    void *null80;                                         //  80   00000000
    void *pTAP_SetSoundLevel;                             //  84   80177f10
    void *pTAP_GetTim;                                    //  88   80177f9c
    void *pTAP_MemInfo;                                   //  8c   80177c60
    void *pTAP_MemAlloc;                                  //  90   80177d44
    void *pTAP_MemFree;                                   //  94   80177e4c
    void *pTAP_GetTick;                                   //  98   80178038
    void *pTAP_Delay;                                     //  9c   801780cc
    void *pTAP_ExtractMjd;                                //  a0   80178158
    void *pTAP_MakeMjd;                                   //  a4   80178200
    void *pTAP_Sin;                                       //  a8   8017829c
    void *pTAP_Cos;                                       //  ac   80178330
    void *pTAP_SPrint;                                    //  b0   801775e4
    void *pTAP_GetSignalLevel;                            //  b4   801783c4
    void *pTAP_GetSignalQuality;                          //  b8   80178498
    void *pTAP_SetInfoboxTime;                            //  bc   80178530
    void *pTAP_PlayPCM;                                   //  c0   80178fdc
    void *pTAP_CaptureScreen;                             //  c4   801785ec
    void *pTAP_GetSystemVar;                              //  c8   80178c38
    void *pTAP_SetSystemVar;                              //  cc   801786d8
    void *pTAP_WriteSystemVar;                            //  d0   80178e68
    void *pTAP_GenerateEvent;                             //  d4   80179084
    void *nulld8;                                         //  d8   00000000
    void *pTAP_Osd_Create;                                //  dc   80179154
    void *pTAP_Osd_Delete;                                //  e0   801793a4
    void *pTAP_Osd_Move;                                  //  e4   80179574
    void *pTAP_Osd_FillBox;                               //  e8   80179658
    void *pTAP_Osd_PutBox;                                //  ec   80179770
    void *pTAP_Osd_GetBox;                                //  f0   801798a0
    void *pTAP_Osd_SetLut;                                //  f4   801799c0
    void *pTAP_Osd_Ctrl;                                  //  f8   80179aa4
    void *pTAP_Osd_SetTransparency;                       //  fc   80179b6c
    void *pTAP_Osd_Draw3dBox;                             // 100   80179c2c
    void *pTAP_Osd_Draw3dBoxFill;                         // 104   80179d48
    void *pTAP_Osd_DrawRectangle;                         // 108   80179e6c
    void *pTAP_Osd_PutGd__;                               // 10c   80179f8c
    void *pTAP_Osd_DrawPixmap;                            // 110   8017a090
    void *pTAP_Osd_Zoom;                                  // 114   8017a1b8
    void *pTAP_Osd_GetBaseInfo;                           // 118   8017a380
    void *pNullsub11c;                                    // 11c   80176f58
    void *pNullsub120;                                    // 120   80176f58
    void *pNullsub124;                                    // 124   80176f58
    void *pTAP_Osd_Copy;                                  // 128   8017a638
    void *pTAP_Osd_SaveBox;                               // 12c   8017a768
    void *pTAP_Osd_RestoreBox;                            // 130   8017a878
    void *pTAP_Osd_GetPixel;                              // 134   8017a988
    void *pTAP_Osd_PutPixel;                              // 138   8017aa7c
    void *pNullsub13c;                                    // 13c   80176f58
    void *null140;                                        // 140   00000000
    void *null144;                                        // 144   00000000
    void *null148;                                        // 148   00000000
    void *null14c;                                        // 14c   00000000
    void *null150;                                        // 150   00000000
    void *null154;                                        // 154   00000000
    void *null158;                                        // 158   00000000
    void *null15c;                                        // 15c   00000000
    void *null160;                                        // 160   00000000
    void *null164;                                        // 164   00000000
    void *pTAP_Hdd_Fopen;                                 // 168   8017ab70
    void *pTAP_Hdd_Fread;                                 // 16c   8017ae38
    void *pTAP_Hdd_Fwrite;                                // 170   8017af30
    void *pTAP_Hdd_Fclose;                                // 174   8017ac6c
    void *pTAP_Hdd_FindFirst;                             // 178   8017b028
    void *pTAP_Hdd_FindNext;                              // 17c   8017b0f4
    void *pTAP_Hdd_Fseek;                                 // 180   8017b1c0
    void *pTAP_Hdd_Flen;                                  // 184   8017b2a8
    void *pTAP_Hdd_Ftell;                                 // 188   8017b368
    void *pTAP_Hdd_TotalSize;                             // 18c   8017b428
    void *pTAP_Hdd_FreeSize;                              // 190   8017b4e4
    void *pTAP_Hdd_Delete;                                // 194   8017ad38
    void *pTAP_Hdd_Exist;                                 // 198   8017b5a0
    void *pTAP_Hdd_Create;                                // 19c   8017b664
    void *pTAP_Hdd_ChangeDir;                             // 1a0   8017b73c
    void *pTAP_Hdd_PlayTs;                                // 1a4   8017b81c
    void *pTAP_Hdd_StopTs;                                // 1a8   8017b8e0
    void *pTAP_Hdd_PlayMp3;                               // 1ac   8017b9f4
    void *pTAP_Hdd_StopMp3;                               // 1b0   8017bab4
    void *pTAP_Hdd_Rename;                                // 1b4   8017bbec
    void *pTAP_Hdd_StartRecord;                           // 1b8   8017bcc8
    void *pTAP_Hdd_StopRecord;                            // 1bc   8017bd60
    void *pTAP_Hdd_GetRecInfo;                            // 1c0   8017be2c
    void *pTAP_Hdd_GetPlayInfo;                           // 1c4   8017c078
    void *pTAP_Hdd_GetHddID;                              // 1c8   8017c828
    void *pTAP_Osd_PutS;                                  // 1cc   8017c890
    void *pTAP_Osd_GetW;                                  // 1d0   8017c9c8
    void *pTAP_Osd_PutString;                             // 1d4   8017ca5c
    void *pTAP_Osd_DrawString;                            // 1d8   8017cb98
    void *pTAP_Osd_PutStringAf;                           // 1dc   8017cc5c
    void *pTAP_Win_SetTitle;                              // 1e0   8017cd8c
    void *pTAP_Win_SetColor;                              // 1e4   8017ce18
    void *pTAP_Win_SetDefaultColor;                       // 1e8   8017cefc
    void *pTAP_Win_Draw;                                  // 1ec   8017cf88
    void *pTAP_Win_Create;                                // 1f0   8017d014
    void *pTAP_Win_Delete;                                // 1f4   8017d120
    void *pTAP_Win_SetFont;                               // 1f8   8017d1c8
    void *pTAP_Win_AddItem;                               // 1fc   8017d254
    void *pTAP_Win_GetSelection;                          // 200   8017d2e4
    void *pTAP_Win_SetSelection;                          // 204   8017d378
    void *pTAP_Win_Action;                                // 208   8017d404
    void *null20c;                                        // 20c   00000000
    void *null210;                                        // 210   00000000
    void *null214;                                        // 214   00000000
    void *null218;                                        // 218   00000000
    void *null21c;                                        // 21c   00000000
    void *pTAP_Channel_StopMainSub;                       // 220   8017d5f4  undocumented  int  exTAP_Channel_StopMainSub(void);
    void *pTAP_nullsub224;                                // 224   8017d694  undocumented  void exTAP_TAP_nullsub3(void);
    void *pTAP_nullsub228;                                // 228   8017d6fc  undocumented  void exTAP_TAP_nullsub4(void);
    void *pTAP_nullsub22c;                                // 22c   8017d764  undocumented  void exTAP_TAP_nullsub5(void);
    void *pTAP_nullsub230;                                // 230   8017d7cc  undocumented  void exTAP_TAP_nullsub6(void);
    void *pTAP_nullsub234;                                // 234   8017d834  undocumented  void exTAP_TAP_nullsub7(void);
    void *pTAP_nullsub238;                                // 238   8017d89c  undocumented  void exTAP_TAP_nullsub8(void);
    int  *pTAP_nullsub23c;                                // 23c   8017d904  undocumented  int  exTAP_TAP_nullsub9(void);
    void *pTAP_nullsub240;                                // 240   8017d96c  undocumented  void exTAP_TAP_nullsub10(void);
    void *null244;                                        // 244   00000000
    void *null248;                                        // 248   00000000
    void *null24c;                                        // 24c   00000000
    void *null250;                                        // 250   00000000
    void *null254;                                        // 254   00000000
    void *null258;                                        // 258   00000000
    void *null25c;                                        // 25c   00000000
    void *null260;                                        // 260   00000000
    void *null264;                                        // 264   00000000
    void *null268;                                        // 268   00000000
    void *pTAP_Channel_GetTotalNum;                       // 26c   8017d9d4
    void *pTAP_Channel_GetFirstInfo;                      // 270   8017da4c
    void *pTAP_Channel_GetNextInfo;                       // 274   8017dfe4
    void *pTAP_Channel_GetInfo;                           // 278   8017e0bc
    void *pTAP_Channel_GetCurrent;                        // 27c   8017e180
    void *pTAP_Channel_Start;                             // 280   8017e290
    void *pTAP_Channel_Scale;                             // 284   8017e448
    void *pTAP_Channel_IsPlayable;                        // 288   8017e500
    void *pTAP_Channel_Move;                              // 28c   8017e5d4
    void *pTAP_Channel_Stop;                              // 290   8017e38c
    void *pTAP_Channel_GetTotalAudioTrack;                // 294   8017e668
    void *pTAP_Channel_GetAudioTrackName;                 // 298   8017e6d8
    void *pTAP_Channel_SetAudioTrack;                     // 29c   8017e7b8
    void *pTAP_Channel_GetTotalSubtitleTrack;             // 2a0   8017e864
    void *pTAP_Channel_GetSubtitleTrackName;              // 2a4   8017e8d4
    void *pTAP_Channel_SetSubtitleTrack;                  // 2a8   8017e9b4
    void *pTAP_Channel_GetCurrentSubTV;                   // 2ac   8017e21c
    void *null2b0;                                        // 2b0   00000000
    void *null2b4;                                        // 2b4   00000000
    void *null2b8;                                        // 2b8   00000000
    void *null2bc;                                        // 2bc   00000000
    void *null2c0;                                        // 2c0   00000000
    void *null2c4;                                        // 2c4   00000000
    void *null2c8;                                        // 2c8   00000000
    void *null2cc;                                        // 2cc   00000000
    void *null2d0;                                        // 2d0   00000000
    void *pTAP_GetEvent;                                  // 2d4   8017f728
    void *pTAP_GetCurrentEvent;                           // 2d8   8017fc08
    void *pTAP_PutEvent;                                  // 2dc   8017feac
    void *null2e0;                                        // 2e0   00000000
    void *null2e4;                                        // 2e4   00000000
    void *pTAP_Timer_GetTotalNum;                         // 2e8   80180420
    void *pTAP_Timer_GetInfo;                             // 2ec   801804c4
    void *pTAP_Timer_Add;                                 // 2f0   80180624
    void *pTAP_Timer_Modify;                              // 2f4   801806f0
    void *pTAP_Timer_Delete;                              // 2f8   80180b3c
    void *null2fc;                                        // 2fc   00000000
    void *null300;                                        // 300   00000000
    void *pTAP_Usb_Read;                                  // 304   8017eea8
    void *pTAP_Usb_Write;                                 // 308   8017ef44
    void *pTAP_Usb_PacketRead;                            // 30c   8017efe0
    void *pTAP_Usb_PacketWrite;                           // 310   8017f07c
    void *pTAP_Usb_Cancel;                                // 314   8017f118
    void *null318;                                        // 318   00000000
    void *null31c;                                        // 31c   00000000
} type_TAPEntryPoints;

typedef struct
{
    dword firmwaregp;
    dword tapgp;
    dword HeapAlloc;                        //tap malloc base address, before + 7ffe, & 0xFFFF8000
    type_TAPHeader *header;                 //after & 0xffff8000
    type_TAPEntryPoints *entryPoints;
    dword loadAddress;
    dword *currentDir;                      //pointer to this taps current directory ?
    dword zero;                             //exit flag
} type_TAPProcess;

enum
{
    oTAP_Hdd_ReadSectorDMA     = 0x00,  //undocumented - int TAP_Hdd_ReadSectorDMA(int startSector, word sectors, byte *buffer);    hdd related, called by debug functions 'rs', 'rc'     -- read sector?
    oTAP_Hdd_WriteSectorDMA    = 0x01,  //undocumented - int TAP_Hdd_WriteSectorDMA(int startSector, word sectors, byte *buffer);   hdd related, called by debug functions 'ws', 'wc'     -- write sector?
    oTAP_unknown2              = 0x02,  //undocumented - int TAP_unknown2(void);                                writes to eeprom @ 0xa3ffffe0, 0xa3ffffe1
    oTAP_Hdd_unknown3          = 0x03,  //undocumented - int TAP_Hdd_unknown3(int);                             ata related, ??? format ??? - more likely init()
    oTAP_Hdd_SetBookmark       = 0x04,
    oTAP_Hdd_GotoBookmark      = 0x05,
    oTAP_Hdd_ChangePlaybackPos = 0x06,
    oTAP_ControlEit            = 0x07,
    oTAP_SetBk                 = 0x08,
    oTAP_EPG_UpdateEvent       = 0x09,
    oTAP_EPG_DeleteEvent       = 0x0a,
    oTAP_EPG_GetExtInfo        = 0x0b,
    oTAP_Channel_IsStarted     = 0x0c,
    oTAP_Vfd_GetStatus         = 0x0d,
    oTAP_Vfd_Control           = 0x0e,
    oTAP_Vfd_SendData          = 0x0f,
    oTAP_Win_SetAvtice         = 0x10,
    oTAP_Win_SetDrawItemFunc   = 0x11,
    oTAP_GetTuner              = 0x12,  //undocumented - byte TAP_GetTuner(int mainSub);
    oTAP_Hdd_Move              = 0x13,  //undocumented - int TAP_Hdd_Move(char *from_dir, char *to_dir, char *filename);
    oTAP_Osd_unknown20         = 0x14,  //undocumented - int TAP_Osd_unknown20(dword *);        osd related, ???, variant of TAP_Osd_GetPlaneBaseInfo(&osdBaseInfo)
//v12.88 only
    oTAP_Channel_SwapMainSub   = 0x15,  //undocumented - int TAP_Channel_SwapMainSub(void);
};
extern void *(*TAP_GetSystemProc)(int id);
extern int   (*TAP_Hdd_ReadSectorDMA)(int mode, word, byte *buffer);
extern int   (*TAP_Hdd_WriteSectorDMA)(int mode, word, byte *buffer);
extern void  (*TAP_unknown2)(void);
extern int   (*TAP_Hdd_unknown3)(int);
extern byte  (*TAP_GetTuner)(int mainSub);
extern dword (*TAP_Hdd_Move)(char *from_dir, char *to_dir, char *filename);
extern int   (*TAP_Osd_unknown20)(dword *);
extern int   (*TAP_Channel_SwapMainSub)(void);

extern int  (*TAP_Channel_StopMainSub)(void);           //TAP_Channel_StopMainSub(), returns 1;
extern void (*TAP_undoc11)(int mode, int enable);       //disable/enable pop up [0=info,1=pip,2-volume,3=no signal]

//----------------------------------------------------------------------------
//81daa2c6 : 00 01 00 00 00 05 ff ff ff ff 11 03 00 51 05 05
//81daa2d6 : ff 00 0c 2a 01 01 00 00 24 00 00 02 00 ff ff 00
//81daa2e6 : 00 00 00 00 00 00 f0 41 00 00 ff 00 0f 14 ff 00
//81daa2f6 : 00 00 00 00 f4 76 00 ff 00 03 00 00 00 00 00 00
//81daa306 : 00 00 00 00 00 00
/*
from firebird
Offset  Length  Field                   Remarks

etc info
0x00    2       CRC16
0x02    2       TV Channel Sub
0x04    2       TV Channel Main
0x06    2       Radio Channel
0x08    2       Old TV Channel          Unused (0xFF)?
0x0A    2       Old Radio Channel       Unused (0xFF)?
0x0C    1       Volume
0x0D    1       Flags
                                        0... .... Service Type (0 = TV, 1 = Radio)
                                        .00. .... Sound Mode (0=Stereo, 1=Mono, 2=Left, 3=Right)
                                        ...0 0... Scart Output Source
                                        .... .01. Video Output (0=CVBS, 1=RGB, 2=S-Video, 3=YUV)
                                        .... ...0 TV Aspect Ratio (0=4:3, 1=16:9)
0x0E    1       Flags
                                        00.. .... Video Standard ()
                                        ..00 1111 RF Channel
0x0F    1       Flags
                                        001. .... RF Output (0=NTSC-M, 1=PAL-G, 2=PAL-I, 3=PAL-K)
                                        ...0 .... Disable Subtitle
                                        .... 0... Disable Teletext
                                        .... .00. 16:9 Display Format (0=letterbox, 1=center extract)
                                        .... ...0 Dolby
0x10    1       InfoBox Hide Time       In seconds
0x11    1       Active Fav. Number
0x12    1       Current Fav. Group Nr.  (0xFF means that no group is active)
0x13    1
                                        0000 11.. Infobox Position
                                        .... ..00 TV Type (0=Multi, 1=PAL, 2=NTSC)
0x14    1       Transparency
0x15
                                        0... .... MovingConfirmBox
                                        .0.. .... satDelete
                                        ..0. .... Scart Type (0=Standard, 1=External A/V)
                                        ...0 1... PIP Position
                                        .... .1.. Svc Help Window
                                        .... ..0. Time Shift
                                        .... ...0 unused
0x16    1       Current Tuner Sub       0=Tuner 1, 1=Tuner 2
0x17    1       Current Tuner Main      0=Tuner 1, 1=Tuner 2
0x18    2       MultiFeed Service Nr.
0x1A    1       rfChannel               UHF channel number
0x1B    7       unused

Parental Info
0x22    2       CRC16
0x24    2       PIN Code
0x26    1       Rate                    0=No block, 1=4 years, 2= 5 years,, 15=18 years, 16=Total block
0x27    1       Lock Flags              B7 = Time Setting locked/unlocked
                                        B6 = Language Setting
                                        B5 = A/V Output Setting
                                        B4 = Organizing Services
                                        B3 = Organizing Favorites
                                        B2 = Common Interface
                                        B1 = Installation
                                        B0 = Boot Lock

Language Info
0x28    2       CRC16
0x2A    1       Menu                    0 = English, 1 = French, 2 = Deutsch, 3 = Italian, 4 = Spanish,
                                        5 = Arabic, 6 = Greek, 7 = Trkce, 8 = Danish, 9 = Swedish,
                                        10 = Norwegian, 11 = Dutch, 12 = Russian, 13 = Polish,
                                        14 = Persian, 15 = Suomi, 16 = Slovak
0x2B    1       Teletext                See above
0x2C    1       Subtitle                See above
0x2D    1       Audio                   See above

Recent Info
0x2E    2       CRC16
0x30
...
0x35

MyPos Info (USALS)
0x36    2       CRC16
0x38    2       Longitude               *10
0x3A    2       Latitude                *10

List Info
0x3C    2       CRC16
0x3E    1       Show Provider           (0=off, 1=on)
0x3F    1       Sat Index
0x40    1       Sort Mode               (0=none, 1=name, 2=Satellite, 3=FTA/CAS, 4=CAS/FTA,
                                        5=Provider, 6=FAV/No FAV)
0x41    1       Tuner                   (1=Tuner 1, 2=Tuner 2, 3=All Tuner)
0x42    6       Unused

?
0x48    2       CRC16
0x4A
...
0x51

?
0x52    170     Unused
0xFC    1       Power Status            0x44 = Standby, 0x88 = On
0xFD    1                               0xFF
0xFE    1                               0xFF
0xFF    1                               0x00
*/

typedef struct {
    word TvSubSvcNum;                      //0001          TV Channel Sub
    word TvSvcNum;                         //0000          TV Channel Main
    word RadioSvcNum;                      //0005          Radio Channel
    word TvOldSvcNum;                      //ffff          Old TV Channel     (at 'run')
    word RadioOldSvcNum;                   //ffff          Old Radio Channel
    byte SYSVAR_Vol;                       //11            Volume
    byte byte_0b;                          //03            Flags
//        d[7] = Service Type (0 = TV, 1 = Radio)
//      d[6:5] = Sound Mode (0=Stereo, 1=Mono, 2=Left, 3=Right)
//      d[4:3] = Scart Output Source
//      d[2:1] = Video Output (0=CVBS, 1=RGB, 2=S-Video, 3=YUV)     SYSVAR_VideoOut
//        d[0] = TV Aspect Ratio (0=4:3, 1=16:9)
    byte byte_0c;                          //00            Flags                        help
    byte byte_0d;                          //51            Flags
//      d[7:5] = RF Output (0=NTSC-M, 1=PAL-G, 2=PAL-I, 3=PAL-K)
//        d[4] = Disable Subtitle
//        d[3] = Disable Teletext
//      d[2:1] = 16:9 Display Format (0=letterbox, 1=center extract)
//        d[0] = Dolby
    byte SYSVAR_IBoxTime;                  //05            InfoBox Hide Time       In seconds
    byte ActiveFavNumber;                  //05            Active Fav. Number
    byte CurrentFavGroup;                  //ff            Current Fav. Group Nr.  (0xFF means that no group is active)
    byte SYSVAR_IBoxPos;                   //00            Infobox Position             d[1:0] = vst
    byte SYSVAR_OsdAlpha;                  //0c            Transparency
    byte byte_13;                          //2a
//        d[7] = MovingConfirmBox
//        d[6] = satDelete
//        d[5] = Scart Type (0=Standard, 1=External A/V)   SYSVAR_ScartType
//      d[4:3] = PIP Position
//        d[2] = Svc Help Window
//        d[1] = Time Shift
//        d[0] =
    byte CurrentTunerSub;                  //01            Current Tuner Sub       0=Tuner 1, 1=Tuner 2
    byte CurrentTunerMain;                 //01            Current Tuner Main      0=Tuner 1, 1=Tuner 2
    word MultifeedServiceNum;              //0000          MultiFeed Service Nr.
    byte SYSVAR_UhfCh;                     //24            rfChannel
    byte byte_19;                          //00
    byte byte_1a;                          //00
    byte byte_1b;                          //02
    byte byte_1c;                          //00
//       d[7] = reboot flag
//       d[5] = interactive_disable
    byte byte_1d;                          //ff
    word word_1e;                          //ff 00

    dword dword_20;                        //00 00 00 00
    word word_24;                          //00 00

    word word_26;                          //f0 41          crc16
    dword dword_28;                        //00 00 ff 00

    word word_2c;                          //0f 14          crc16
    word word_2e;                          //ff 00
    dword dword_30;                        //00 00 00 00

    word word_34;                          //f4 76          crc16
    word word_36;                          //00 ff
    dword dword_38;                        //00 03 00 00
    dword dword_3c;                        //00 00 00 00
    dword dword_40;                        //00 00 00 00
    word word_44;                          //00 00

}type_etc_structure;
//etc_structure  - eeprom map - len=0x20

extern dword fw_etc_structure;
extern dword fw_pip_position_offset;
extern dword fw_afd_offset;
extern dword fw_sequence_header_offset;
//----------------------------------------------------------------------------
//
//firmware addresses
//
extern void *fw_TAP_GetCurrentEvent;
extern void *fw_TAP_GetSignalLevel;
extern void *fw_TAP_GetSystemProc;
extern void *fw_TAP_KbHit;

extern dword fw_tap_ident;
extern dword fw_tap_table;
extern dword fw_gp;

extern void *fw_add_task_queue;

extern void *fw_channel_scale;
extern void *fw_DbgSi_LoadDmx;
extern void *fw_display_func;
extern void *fw_enable_tshift;
extern void *fw_event_alloc;
extern void *fw_event_delete;
extern void *fw_fChangePlaybackPos;
extern void *fw_findfirst;
extern void *fw_get_channel_info;
extern void *fw_get_genre_str;
extern void *fw_grab_screen_image;
extern void *fw_hdd_move;
extern void *fw_ioctl;
extern void *fw_is_recording;
extern void *fw_key_map_patch;
extern void *fw_key_map_patch2;
extern void *fw_mheg_disable;
extern void *fw_os_free;
extern void *fw_process_dsmcc;
extern void *fw_process_eit;
extern void *fw_process_tdt;
extern void *fw_process_tot;
extern void *fw_set_wss;
extern void *fw_shutdown_irq_disable;
extern void *fw_shutdown_irq_enable;
extern void *fw_shutdown_task;
extern void *fw_StartRecord;
extern void *fw_stop_tshift;
extern void *fw_tap_load;
extern void *fw_translate_and_display;
extern void *fw_utctolocal_time;

extern dword fw_afd;
extern char *fw_display_string;
extern type_eventtable *fw_epg_highlighted_event;
extern byte *fw_epg_refresh;
extern void *fw_epgstck_patch;
extern type_eventbuffer *fw_event_buffer;
extern type_eventtable *fw_event_table;
extern int fw_event_table_size;
extern dword *fw_ext_function_table;
extern int fw_max_events;
extern dword *fw_mheg_entry;
extern int fw_num_ext_functions;
extern dword *fw_pcr1_pid;
extern dword fw_play_info;
extern dword fw_play_header;
extern dword fw_rec_info;
extern dword fw_rec_header;
extern dword fw_sequence_header;
extern dword *fw_tap_load_data0;
extern dword *fw_tap_load_data1;
extern dword *fw_tap_load_data2;
extern dword fw_ts_struct1;
extern dword fw_ts_struct2;
extern dword *fw_tshift_block_offset;
extern byte *fw_tshift_slot;
extern word *fw_twinkle;
extern type_taptime *fw_utc_time;

extern type_flash *fw_flash;
extern type_timer_block *fw_timer_table;
extern int fw_timer_table_size;
extern int fw_max_timers;

extern type_aspect fw_aspect[2];
//----------------------------------------------------------------------------
extern void *fw_pattern_afd;
extern void *fw_pattern_epg_highlighted_event;
extern void *fw_pattern_epg_highlighted_event2;
extern void *fw_pattern_epg_refresh;
extern void *fw_pattern_mheg_entry;
extern void *fw_pattern_mheg_entry2;
extern void *fw_pattern_pcr1_pid;
extern void *fw_pattern_sequence_header;
extern void *fw_pattern_tap_load_data1;
extern void *fw_pattern_tap_load_data1_2;
extern void *fw_pattern_twinkle;
extern void *fw_pattern_ts_struct1;
extern void *fw_pattern_ts_struct2;
extern void *fw_pattern_tshift_block_offset;

extern void *fw_pattern_flash;
extern void *fw_pattern_timer;
//----------------------------------------------------------------------------
#endif //_TOPFIELD_H_
